GLM: GLM_GTC_quaternion

GLM 0.9.5

- Main Page
- Related Pages
- Modules
- Namespaces
- Files

Functions
GLM_GTC_quaternion
GTC Extensions (Stable)

## Functions
template<typename T , precision P>
GLM_FUNC_DECL T | angle (detail::tquat< T, P > const &x)
template<typename T , precision P>
GLM_FUNC_DECL detail::tquat< T, P > | angleAxis (T const &angle, detail::tvec3< T, P > const &axis)
template<typename T , precision P>
GLM_FUNC_DECL detail::tvec3< T, P > | axis (detail::tquat< T, P > const &x)
template<typename T , precision P>
GLM_FUNC_DECL detail::tquat< T, P > | conjugate (detail::tquat< T, P > const &q)
template<typename T , precision P, template< typename, precision > class quatType>
GLM_FUNC_DECL T | dot (quatType< T, P > const &x, quatType< T, P > const &y)
template<typename T , precision P>
GLM_FUNC_DECL detail::tvec4 < bool, P > | equal (detail::tquat< T, P > const &x, detail::tquat< T, P > const &y)
template<typename T , precision P>
GLM_FUNC_DECL detail::tvec3< T, P > | eulerAngles (detail::tquat< T, P > const &x)
template<typename T , precision P>
GLM_FUNC_DECL detail::tvec4 < bool, P > | greaterThan (detail::tquat< T, P > const &x, detail::tquat< T, P > const &y)
template<typename T , precision P>
GLM_FUNC_DECL detail::tvec4 < bool, P > | greaterThanEqual (detail::tquat< T, P > const &x, detail::tquat< T, P > const &y)
template<typename T , precision P>
GLM_FUNC_DECL detail::tquat< T, P > | inverse (detail::tquat< T, P > const &q)
template<typename T , precision P>
GLM_FUNC_DECL T | length (detail::tquat< T, P > const &q)
template<typename T , precision P>
GLM_FUNC_DECL detail::tquat< T, P > | lerp (detail::tquat< T, P > const &x, detail::tquat< T, P > const &y, T const &a)
template<typename T , precision P>
GLM_FUNC_DECL detail::tvec4 < bool, P > | lessThan (detail::tquat< T, P > const &x, detail::tquat< T, P > const &y)
template<typename T , precision P>
GLM_FUNC_DECL detail::tvec4 < bool, P > | lessThanEqual (detail::tquat< T, P > const &x, detail::tquat< T, P > const &y)
template<typename T , precision P>
GLM_FUNC_DECL detail::tmat3x3 < T, P > | mat3_cast (detail::tquat< T, P > const &x)
template<typename T , precision P>
GLM_FUNC_DECL detail::tmat4x4 < T, P > | mat4_cast (detail::tquat< T, P > const &x)
template<typename T , precision P>
GLM_FUNC_DECL detail::tquat< T, P > | mix (detail::tquat< T, P > const &x, detail::tquat< T, P > const &y, T const &a)
template<typename T , precision P>
GLM_FUNC_DECL detail::tquat< T, P > | normalize (detail::tquat< T, P > const &q)
template<typename T , precision P>
GLM_FUNC_DECL detail::tvec4 < bool, P > | notEqual (detail::tquat< T, P > const &x, detail::tquat< T, P > const &y)
template<typename T , precision P>
GLM_FUNC_DECL T | pitch (detail::tquat< T, P > const &x)
template<typename T , precision P>
GLM_FUNC_DECL detail::tquat< T, P > | quat_cast (detail::tmat3x3< T, P > const &x)
template<typename T , precision P>
GLM_FUNC_DECL detail::tquat< T, P > | quat_cast (detail::tmat4x4< T, P > const &x)
template<typename T , precision P>
GLM_FUNC_DECL T | roll (detail::tquat< T, P > const &x)
template<typename T , precision P>
GLM_FUNC_DECL detail::tquat< T, P > | rotate (detail::tquat< T, P > const &q, T const &angle, detail::tvec3< T, P > const &axis)
template<typename T , precision P>
GLM_FUNC_DECL detail::tquat< T, P > | slerp (detail::tquat< T, P > const &x, detail::tquat< T, P > const &y, T const &a)
template<typename T , precision P>
GLM_FUNC_DECL T | yaw (detail::tquat< T, P > const &x)

## Detailed Description

Defines a templated quaternion type and several quaternion operations.

<glm/gtc/quaternion.hpp> need to be included to use these functionalities.

## Function Documentation

GLM_FUNC_DECL T glm::angle | ( | detail::tquat< T, P > const & | x | ) |

Returns the quaternion rotation angle.

See Also
  GLM_GTC_quaternion

GLM_FUNC_DECL detail::tquat<T, P> glm::angleAxis | ( | T const & | angle,
|  | detail::tvec3< T, P > const & | axis
| ) |  |

Build a quaternion from an angle and a normalized axis.

Parameters

  angle | Angle expressed in radians if GLM_FORCE_RADIANS is define or degrees otherwise.
  axis | Axis of the quaternion, must be normalized.

See Also
  GLM_GTC_quaternion

GLM_FUNC_DECL detail::tvec3<T, P> glm::axis | ( | detail::tquat< T, P > const & | x | ) |

Returns the q rotation axis.

See Also
  GLM_GTC_quaternion

GLM_FUNC_DECL detail::tquat<T, P> glm::conjugate | ( | detail::tquat< T, P > const & | q | ) |

Returns the q conjugate.

See Also
  GLM_GTC_quaternion

GLM_FUNC_DECL T glm::dot | ( | quatType< T, P > const & | x,
|  | quatType< T, P > const & | y
| ) |  |

Returns dot product of q1 and q2, i.e., q1[0] * q2[0] + q1[1] * q2[1] + ...

See Also
  GLM_GTC_quaternion

GLM_FUNC_DECL detail::tvec4<bool, P> glm::equal | ( | detail::tquat< T, P > const & | x,
|  | detail::tquat< T, P > const & | y
| ) |  |

Returns the component-wise comparison of result x == y.

Template Parameters

  quatType | Floating-point quaternion types.

See Also
  GLM_GTC_quaternion

GLM_FUNC_DECL detail::tvec3<T, P> glm::eulerAngles | ( | detail::tquat< T, P > const & | x | ) |

Returns euler angles, yitch as x, yaw as y, roll as z.

The result is expressed in radians if GLM_FORCE_RADIANS is defined or degrees otherwise.

See Also
  GLM_GTC_quaternion

GLM_FUNC_DECL detail::tvec4<bool, P> glm::greaterThan | ( | detail::tquat< T, P > const & | x,
|  | detail::tquat< T, P > const & | y
| ) |  |

Returns the component-wise comparison of result x > y.

Template Parameters

  quatType | Floating-point quaternion types.

See Also
  GLM_GTC_quaternion

GLM_FUNC_DECL detail::tvec4<bool, P> glm::greaterThanEqual | ( | detail::tquat< T, P > const & | x,
|  | detail::tquat< T, P > const & | y
| ) |  |

Returns the component-wise comparison of result x >= y.

Template Parameters

  quatType | Floating-point quaternion types.

See Also
  GLM_GTC_quaternion

GLM_FUNC_DECL detail::tquat<T, P> glm::inverse | ( | detail::tquat< T, P > const & | q | ) |

Returns the q inverse.

See Also
  GLM_GTC_quaternion

GLM_FUNC_DECL T glm::length | ( | detail::tquat< T, P > const & | q | ) |

Returns the length of the quaternion.

See Also
  GLM_GTC_quaternion

GLM_FUNC_DECL detail::tquat<T, P> glm::lerp | ( | detail::tquat< T, P > const & | x,
|  | detail::tquat< T, P > const & | y,
|  | T const & | a
| ) |  |

Linear interpolation of two quaternions.

The interpolation is oriented.

Parameters

  x | A quaternion
  y | A quaternion
  a | Interpolation factor. The interpolation is defined in the range [0, 1].

Template Parameters

  T | Value type used to build the quaternion. Supported: half, float or double.

See Also
  GLM_GTC_quaternion

GLM_FUNC_DECL detail::tvec4<bool, P> glm::lessThan | ( | detail::tquat< T, P > const & | x,
|  | detail::tquat< T, P > const & | y
| ) |  |

Returns the component-wise comparison result of x < y.

Template Parameters

  quatType | Floating-point quaternion types.

See Also
  GLM_GTC_quaternion

GLM_FUNC_DECL detail::tvec4<bool, P> glm::lessThanEqual | ( | detail::tquat< T, P > const & | x,
|  | detail::tquat< T, P > const & | y
| ) |  |

Returns the component-wise comparison of result x <= y.

Template Parameters

  quatType | Floating-point quaternion types.

See Also
  GLM_GTC_quaternion

GLM_FUNC_DECL detail::tmat3x3<T, P> glm::mat3_cast | ( | detail::tquat< T, P > const & | x | ) |

Converts a quaternion to a 3 * 3 matrix.

See Also
  GLM_GTC_quaternion

Referenced by glm::toMat3().

GLM_FUNC_DECL detail::tmat4x4<T, P> glm::mat4_cast | ( | detail::tquat< T, P > const & | x | ) |

Converts a quaternion to a 4 * 4 matrix.

See Also
  GLM_GTC_quaternion

Referenced by glm::toMat4().

GLM_FUNC_DECL detail::tquat<T, P> glm::mix | ( | detail::tquat< T, P > const & | x,
|  | detail::tquat< T, P > const & | y,
|  | T const & | a
| ) |  |

Spherical linear interpolation of two quaternions.

The interpolation is oriented and the rotation is performed at constant speed. For short path spherical linear interpolation, use the slerp function.

Parameters

  x | A quaternion
  y | A quaternion
  a | Interpolation factor. The interpolation is defined beyond the range [0, 1].

Template Parameters

  T | Value type used to build the quaternion. Supported: half, float or double.

See Also
  GLM_GTC_quaternion
  - slerp(detail::tquat<T, P> const & x, detail::tquat<T, P> const & y, T const & a)

GLM_FUNC_DECL detail::tquat<T, P> glm::normalize | ( | detail::tquat< T, P > const & | q | ) |

Returns the normalized quaternion.

See Also
  GLM_GTC_quaternion

GLM_FUNC_DECL detail::tvec4<bool, P> glm::notEqual | ( | detail::tquat< T, P > const & | x,
|  | detail::tquat< T, P > const & | y
| ) |  |

Returns the component-wise comparison of result x != y.

Template Parameters

  quatType | Floating-point quaternion types.

See Also
  GLM_GTC_quaternion

GLM_FUNC_DECL T glm::pitch | ( | detail::tquat< T, P > const & | x | ) |

Returns pitch value of euler angles expressed in radians if GLM_FORCE_RADIANS is defined or degrees otherwise.

See Also
  GLM_GTX_quaternion

GLM_FUNC_DECL detail::tquat<T, P> glm::quat_cast | ( | detail::tmat3x3< T, P > const & | x | ) |

Converts a 3 * 3 matrix to a quaternion.

See Also
  GLM_GTC_quaternion

Referenced by glm::toQuat().

GLM_FUNC_DECL detail::tquat<T, P> glm::quat_cast | ( | detail::tmat4x4< T, P > const & | x | ) |

Converts a 4 * 4 matrix to a quaternion.

See Also
  GLM_GTC_quaternion

GLM_FUNC_DECL T glm::roll | ( | detail::tquat< T, P > const & | x | ) |

Returns roll value of euler angles expressed in radians if GLM_FORCE_RADIANS is defined or degrees otherwise.

See Also
  GLM_GTX_quaternion

GLM_FUNC_DECL detail::tquat<T, P> glm::rotate | ( | detail::tquat< T, P > const & | q,
|  | T const & | angle,
|  | detail::tvec3< T, P > const & | axis
| ) |  |

Rotates a quaternion from a vector of 3 components axis and an angle.

Parameters

  q | Source orientation
  angle | Angle expressed in radians if GLM_FORCE_RADIANS is define or degrees otherwise.
  axis | Axis of the rotation

See Also
  GLM_GTC_quaternion

GLM_FUNC_DECL detail::tquat<T, P> glm::slerp | ( | detail::tquat< T, P > const & | x,
|  | detail::tquat< T, P > const & | y,
|  | T const & | a
| ) |  |

Spherical linear interpolation of two quaternions.

The interpolation always take the short path and the rotation is performed at constant speed.

Parameters

  x | A quaternion
  y | A quaternion
  a | Interpolation factor. The interpolation is defined beyond the range [0, 1].

Template Parameters

  T | Value type used to build the quaternion. Supported: half, float or double.

See Also
  GLM_GTC_quaternion

Spherical linear interpolation of two quaternions.

Definition at line 73 of file compatibility.hpp.

References glm::mix().

GLM_FUNC_DECL T glm::yaw | ( | detail::tquat< T, P > const & | x | ) |

Returns yaw value of euler angles expressed in radians if GLM_FORCE_RADIANS is defined or degrees otherwise.

See Also
  GLM_GTX_quaternion